//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include<stdio.h>

#include "SDIMain.h"
#include "About.h"
#include "webupdate.h"
//---------------------------------------------------------------------
#pragma link "ALAudioToReal"
#pragma link "ALCommonSplitter"
#pragma link "SLScope"
#pragma link "VLCommonDisplay"
#pragma link "VLDSVideoPlayer"
#pragma link "VLImageDisplay"
#pragma link "ALAudioOut"
#pragma link "SLWaterfall"
#pragma link "SLFourier"
#pragma link "SLCommonFilter"
#pragma link "SLLowPass"
#pragma link "SLSimpleFilter"
#pragma link "VLAVIPlayer"
#pragma link "SLBandFilter"
#pragma link "SLBandPass"
#pragma link "SLGenericReal"
#pragma link "SLGenericComplex"
#pragma link "SLDft"
#pragma link "SLGoertzOne"
#pragma link "SLGenericFilter"
#pragma link "SHDocVw_OCX"
#pragma link "ALRealToAudio"
#pragma link "ALCommonFilter"
#pragma link "ALGenericFilter"
#pragma resource "*.dfm"
TSDIAppForm *SDIAppForm;
//---------------------------------------------------------------------
__fastcall TSDIAppForm::TSDIAppForm(TComponent *AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------

void __fastcall TSDIAppForm::FileNew1Execute(TObject *Sender)
{
  // Do nothing        
}
//---------------------------------------------------------------------------


void __fastcall TSDIAppForm::FileSave1Execute(TObject *Sender)
{
	if (SaveDialog->Execute()){
		LogMemo->Lines->SaveToFile(SaveDialog->FileName);
	}
}
//---------------------------------------------------------------------------


void __fastcall TSDIAppForm::FileExit1Execute(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TSDIAppForm::HelpAbout1Execute(TObject *Sender)
{
  AboutBox->ShowModal();        
}
//---------------------------------------------------------------------------



	//---------------------------------------------------------------------------
/*
					1209 Hz 	1336 Hz 	1477 Hz 	1633 Hz
	697 Hz 		1 				2 				3 			A
	770 Hz 		4 				5 				6 			B
	852 Hz 		7 				8 				9 			C
	941 Hz 		* 				0 				# 			D
*/

// Globals Here

Real goertzout_h[4]={0,0,0,0};
Real goertzout_l[4]={0,0,0,0};
char *  row_col_ascii_codes[4][4] = {
		{"1", "2", "3", "A"},
		{"4", "5", "6", "B"},
		{"7", "8", "9", "C"},
		{"*", "0", "#", "D"}};
int dtmf_col=0,dtmf_row=0;
char dtmfbuff[64];
int dbc=0;
int scrolled=0;

char utctime[16],sats[16],speed[16],hdg[16],date[16],alt[16];

TWebUpdate * WebUpdater;

long DurationTime=0,CurrentTime=0,CurrentFrame=0,FramesCount=0;

//---------------------------------------------------------------------------

void __fastcall TSDIAppForm::FileOpen1Execute(TObject *Sender)
{

	if (OpenDialog->Execute()) {
		VideoPlayer->Stop();
		Label1->Caption=OpenDialog->FileName;
		VideoPlayer->FileName=OpenDialog->FileName;


		DurationTime=VideoPlayer->DurationTime;
		CurrentTime=VideoPlayer->CurrentTime;

		Label2->Caption="Frame: " +AnsiString(VideoPlayer->CurrentFrame)
			+"/"+AnsiString(VideoPlayer->FramesCount);

		if (VideoPlayer->FramesCount)
			ScrollBar1->Max=VideoPlayer->FramesCount;
	}
	else
		Label1->Caption="No File Loaded";
}
//---------------------------------------------------------------------------

void __fastcall TSDIAppForm::SLGoertzOne1209Calculate(TObject *Sender,
      Real RealValue, Real ImaginaryValue, Real SpectrumValue)
{
	goertzout_h[0]=SpectrumValue;

}
//---------------------------------------------------------------------------


void __fastcall TSDIAppForm::SLGoertzOne1366Calculate(TObject *Sender,
			Real RealValue, Real ImaginaryValue, Real SpectrumValue)
{
	goertzout_h[1]=SpectrumValue;
}
//---------------------------------------------------------------------------

void __fastcall TSDIAppForm::SLGoertzOne1477Calculate(TObject *Sender,
			Real RealValue, Real ImaginaryValue, Real SpectrumValue)
{
	goertzout_h[2]=SpectrumValue;
}
//---------------------------------------------------------------------------

void __fastcall TSDIAppForm::SLGoertzOne1633Calculate(TObject *Sender,
			Real RealValue, Real ImaginaryValue, Real SpectrumValue)
{
	goertzout_h[3]=SpectrumValue;
}
//---------------------------------------------------------------------------

void __fastcall TSDIAppForm::SLGoertzOne697Calculate(TObject *Sender,
			Real RealValue, Real ImaginaryValue, Real SpectrumValue)
{
	goertzout_l[0]=SpectrumValue;
}
//---------------------------------------------------------------------------

                
void __fastcall TSDIAppForm::SLGoertzOne770Calculate(TObject *Sender,
			Real RealValue, Real ImaginaryValue, Real SpectrumValue)
{
	goertzout_l[1]=SpectrumValue;
}
//---------------------------------------------------------------------------

void __fastcall TSDIAppForm::SLGoertzOne852Calculate(TObject *Sender,
			Real RealValue, Real ImaginaryValue, Real SpectrumValue)
{
	goertzout_l[2]=SpectrumValue;
}
//---------------------------------------------------------------------------

void __fastcall TSDIAppForm::SLGoertzOne941Calculate(TObject *Sender,
			Real RealValue, Real ImaginaryValue, Real SpectrumValue)
{
	goertzout_l[3]=SpectrumValue;
}
//---------------------------------------------------------------------------

void TSDIAppForm::parseDTMF()
{
FILE * fp;
//	char utctime[16],lat[16],lon[16],sats[16],speed[16],hdg[16],date[16],alt[16];


	sprintf(utctime,"%c%c:%c%c:%c%c",
		dtmfbuff[1],dtmfbuff[2],dtmfbuff[3],dtmfbuff[4],dtmfbuff[5],dtmfbuff[6]);

    

	sprintf(lat,"%c%c%c%c.%c%c%c%c,%c",
		dtmfbuff[7],dtmfbuff[8],dtmfbuff[9],dtmfbuff[10],dtmfbuff[11],dtmfbuff[12],
		dtmfbuff[13],dtmfbuff[14],dtmfbuff[15]);

	sprintf(lon,"%c%c%c%c%c.%c%c%c%c,%c",
		dtmfbuff[16],dtmfbuff[17],dtmfbuff[18],dtmfbuff[19],dtmfbuff[20],dtmfbuff[21],
		dtmfbuff[22],dtmfbuff[23],dtmfbuff[24],dtmfbuff[25]);


	sprintf(sats,"%c%c",dtmfbuff[26],dtmfbuff[27]);
	sprintf(speed,"%c%c%c.%c%c",dtmfbuff[28],dtmfbuff[29],dtmfbuff[30],dtmfbuff[31],dtmfbuff[32]);
	sprintf(hdg,"%c%c%c",dtmfbuff[33],dtmfbuff[34],dtmfbuff[35]);
	sprintf(date,"%c%c/%c%c/%c%c",dtmfbuff[36],dtmfbuff[37],dtmfbuff[38],
		dtmfbuff[39],dtmfbuff[40],dtmfbuff[41]);
	sprintf(alt,"%c%c%c%c.%c",dtmfbuff[42],dtmfbuff[43],dtmfbuff[44],
		dtmfbuff[45],dtmfbuff[46]);

	LogMemo->Lines->Add((AnsiString)utctime+"@"+
											(AnsiString)date+"@"+
											(AnsiString)lat+"@"+
											(AnsiString)lon+"@"+
											(AnsiString)sats+"@"+
											(AnsiString)hdg+"@"+
											(AnsiString)speed+"@"+
											(AnsiString)alt);



	//SDIAppForm->Memo1->Lines->Text="";
	SDIAppForm->Memo1->Lines->Add("UTC Time:"+(AnsiString)utctime);
	SDIAppForm->Memo1->Lines->Add("Date:"+(AnsiString)date);
	SDIAppForm->Memo1->Lines->Add("Latitude:"+(AnsiString)lat);
	SDIAppForm->Memo1->Lines->Add("Longitude:"+(AnsiString)lon);
	SDIAppForm->Memo1->Lines->Add("Sats:"+(AnsiString)sats);
	SDIAppForm->Memo1->Lines->Add("Hdg:"+(AnsiString)hdg);
	SDIAppForm->Memo1->Lines->Add("SOG:"+(AnsiString)speed);
	SDIAppForm->Memo1->Lines->Add("Altitude:"+(AnsiString)alt);


	fp=fopen(AnsiString(OpenDialog->FileName+".txt").c_str(),"a");

	fprintf(fp,"%ld@%s@%s@%s@%s@%s@%s@%s@%s\n",VideoPlayer->CurrentFrame,utctime,date,lat,lon,sats,hdg,speed,alt);
	fflush(fp);
	fclose(fp);


}

/*
'address	bytes	what		example		format
'80-85		6	UTCTIME:	164924	hhmmss.sss (From GPRMC-1)
'86-94		9	LATITUDE:	3758.5376,N	ddmm.mmmm,N (or S)(From GPRMC-2)
'95-104		10	LONGITUDE:	02347.1589,E	dddmm.mmmm,E (or S)(From GPRMC-3)
'105-106	2	Sats Used:	07		0-12 (From GPGGA-4)
'107-111	5	speed:		xx0.13		(From GPRMC-5)
'112-114	3	direction:	xxx.--		(From GPRMC-5)
'115-120	6	date:		230705		ddmmyy (From GPRMC-6)
'121-125	5	altitude:	x252.8		Meters (From GPGGA-4)
*/
//---------------------------------------------------------------------------



void __fastcall TSDIAppForm::FormCreate(TObject *Sender)
{
	 //CppWebBrowser1->Navigate(WideString("c:/temp/googlemap.html"));

	 //WebUpdater= new TWebUpdate(false);
}
//---------------------------------------------------------------------------
#include <exdispid.h>
#include <mshtml.h>

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <utilcls.h>


void __fastcall TSDIAppForm::FormClose(TObject *Sender, TCloseAction &Action)
{

	//WebUpdater->Terminate();
	// WAIT FOR THREAD TO TERMINATE,
	Sleep(250);
}
//---------------------------------------------------------------------------

void __fastcall TSDIAppForm::StopBtnClick(TObject *Sender)
{
	VideoPlayer->Stop();
}
//---------------------------------------------------------------------------

void __fastcall TSDIAppForm::PlayBtnClick(TObject *Sender)
{
	if (VideoPlayer->Paused) VideoPlayer->Resume();
	else {
		VideoPlayer->Start();
		Label3->Caption=AnsiString(VideoPlayer->CurrentFrame);
	}

}
//---------------------------------------------------------------------------


void __fastcall TSDIAppForm::BitBtn1Click(TObject *Sender)
{
	VideoPlayer->Pause();
}
//---------------------------------------------------------------------------



void __fastcall TSDIAppForm::scrolltimerTimer(TObject *Sender)
{
	VideoPlayer->CurrentFrame=ScrollBar1->Position;
	Sleep(250);
	scrolltimer->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TSDIAppForm::ScrollBar1Scroll(TObject *Sender,
			TScrollCode ScrollCode, int &ScrollPos)
{
	scrolltimer->Enabled=true;

}
//---------------------------------------------------------------------------


void __fastcall TSDIAppForm::VideoPlayerProgress(TObject *Sender,
      __int64 StartFrame, __int64 EndFrame, __int64 CurrentFrame)
{

Memo1->Lines->Add("Called");
//long d=VideoPlayer->DurationTime;
if (!VideoPlayer->FramesCount) return;

	ScrollBar1->Max=VideoPlayer->FramesCount;
	CurrentFrame=VideoPlayer->CurrentFrame;

	Label2->Caption="Frame: " +AnsiString(VideoPlayer->CurrentFrame)
		+"/"+AnsiString(VideoPlayer->FramesCount) ;

	if (scrolltimer->Enabled!=true) //if not scrolling right now
		ScrollBar1->Position=VideoPlayer->CurrentFrame;


//TODO: elegxos kathe tone  >1 fora (apo epomeno sample)
//sunduasmos me sampling rate + timer interval

	int isvalid=1;
	static int oldstatus=0,silence=0;
	int i,valcount=0;
	double maxval_h=0.0,maxval_l=0.0, thres;
	static char dtmfprev=0, dtmfvalid=0;
	static FILE * fp= fopen("c:/temp/dtmfdbg.txt","a");
	static long int silenceval=10000;

	/* Find the largest in the col and row groups. */
	for (i=0;i<4;i++) {
		if ( goertzout_h[i] > maxval_h ) {
			maxval_h = goertzout_h[i];
			dtmf_col = i;
		}
		if ( goertzout_l[i] > maxval_l ) {
			maxval_l = goertzout_l[i];
			dtmf_row = i;
		}
	}

	//thres=0.5*maxval_l; //threshold.
	thres=(ThresBar->Position)/10.0*maxval_l; //threshold.
	if (maxval_l<silenceval) { //energy low
		isvalid=0;
	}
	else if (maxval_h<silenceval) {
		isvalid=0;
	}
	else {
		silence=0;
		// Count values above threshold. We want only 2.
		for (i=0;i<4;i++) {
			if (goertzout_h[i]>thres) valcount++;
			if (goertzout_l[i]>thres) valcount++;
		}
		if (valcount!=2) isvalid=0;
	}


	if (valcount<2) {
		silence++;
		if (silence>100) silence=1;
		silenceval=maxval_l<maxval_h?maxval_l:maxval_h; //silence thresh.
		if (silenceval<10000) silenceval=10000;
	}

	if (dtmfprev==*row_col_ascii_codes[dtmf_row][dtmf_col]) isvalid++;
	dtmfprev=*row_col_ascii_codes[dtmf_row][dtmf_col];
	i=maxval_l>maxval_h?maxval_l:maxval_h;
	Label3->Caption="Max:"+AnsiString((int)i) + ">=" + AnsiString((int)thres)
			+ " LThr:" + AnsiString((int)silenceval);


	//a fresh sample after a silence
	//if ((oldstatus==0) && isvalid>1) {

	if (isvalid==2) { //two consecutive samples indicating the same tone
		dtmfvalid=*row_col_ascii_codes[dtmf_row][dtmf_col];
	}


	fprintf(fp,"%d, %d, %d, %d\n",silence,isvalid,oldstatus,dtmfvalid);


	//invalid or silence now but a tone was detected twice
	if (((silence||(!isvalid)) && dtmfvalid)) {

		fprintf(fp,"%d,%d,[%s], %6.2f,%6.2f\n",
		isvalid,valcount, row_col_ascii_codes[dtmf_row][dtmf_col],maxval_h,maxval_l);


		fflush(fp);

		if ((dbc>60) || (dtmfvalid=='A')) {
			dbc=0;
			Memo1->Lines->Text="";
		}

		dtmfbuff[dbc++]=dtmfvalid;
		//Memo1->Lines->Add(dtmfbuff[dbc-1]);
		Memo1->Lines->Text=Memo1->Lines->Text+dtmfbuff[dbc-1];

		if ((dbc>40) && (dtmfvalid=='B')) {
			dtmfbuff[dbc]=0;
			parseDTMF();
			CppWebBrowser1->Navigate((wchar_t *) WideString(AnsiString("http://www.softlab.ece.ntua.gr/~sivann/google/?lat=")+AnsiString(lat)+AnsiString("&lon=")+AnsiString(lon)));
		}

  	dtmfvalid=0;
	}

	for (i=0;i<4;i++) {
			goertzout_h[i]=0;
			goertzout_l[i]=0;
	}

	oldstatus=isvalid;

}
//---------------------------------------------------------------------------







